//+------------------------------------------------------------------+
//|                                             MaksiGen_chanell.mq4 |
//|                                                                  |
//| original indicator made by OlegVS                                |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Aqua
#property indicator_color2 Violet
#property indicator_color3 DarkTurquoise
#property indicator_color4 Magenta
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 0
#property indicator_width4 0

//
//
//
//
//

extern string Time.start1          = "08:15";
extern string Time.end1            = "17:30";
extern string Time.start2          = "14:00";
extern string Time.end2            = "17:30";
extern int    MinimalChanellHeight = 15;

//
//
//
//
//

double res1[];
double res2[];
double sup1[];
double sup2[];

string st1,st2,et1,et2;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,res1); SetIndexLabel(0,"resistance 1");
   SetIndexBuffer(1,sup1); SetIndexLabel(1,"support 1");
   SetIndexBuffer(2,res2); SetIndexLabel(2,"resistance 2");
   SetIndexBuffer(3,sup2); SetIndexLabel(3,"support 2");
   
      st1 = normalizeTime(Time.start1);
      st2 = normalizeTime(Time.start2);
      et1 = normalizeTime(Time.end1);
      et2 = normalizeTime(Time.end2);
   return(0);
}
int deinit() { Comment(""); return(0); }



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   datetime ts1=-1,ts2,te1,te2;
   int      countedBars=IndicatorCounted();
   int      i,limit;

   if (countedBars<0) return(-1);
   if (countedBars>0) countedBars--;
         limit = Bars-countedBars;

         //
         //
         //
         //
         //
                      
         if (Digits==3 || Digits==5)
            double _point=Point*10;
         else      _point=Point;         

   //
   //
   //
   //
   //
   
   for(i = limit; i >=0; i--)
   {
      if (TimeDayOfYear(ts1) != TimeDayOfYear(Time[i]))
      {
         ts1 = StrToTime(TimeToStr(Time[i],TIME_DATE)+st1);
         ts2 = StrToTime(TimeToStr(Time[i],TIME_DATE)+st2);
         te1 = StrToTime(TimeToStr(Time[i],TIME_DATE)+et1);
         te2 = StrToTime(TimeToStr(Time[i],TIME_DATE)+et2);
      }            
      res1[i] = EMPTY_VALUE;
      res2[i] = EMPTY_VALUE;
      sup1[i] = EMPTY_VALUE;
      sup2[i] = EMPTY_VALUE;

      //
      //
      //
      //
      //

      if  ((Time[i]>=ts1 && Time[i]<te1) || (Time[i]>=ts2 && Time[i]<te2))
         if (res1[i+1] == EMPTY_VALUE)
         {
            int endBar   = iBarShift(NULL,0,StrToTime(TimeToStr(Time[i],TIME_DATE)+" 00:00"));
            int startBar = iBarShift(NULL,0,ts1);
            double   res = High[ArrayMaximum(High,endBar-startBar,startBar+1)];
            double   sup =  Low[ArrayMinimum(Low ,endBar-startBar,startBar+1)];
         
               res1[i] = res; res2[i] = res+10*_point;
               sup1[i] = sup; sup2[i] = sup-10*_point;
         }
         else
         {
               res1[i] = res1[i+1]; res2[i] = res2[i+1];
               sup1[i] = sup1[i+1]; sup2[i] = sup2[i+1];
         }
   }
   
   //
   //
   //
   //
   //

   for (i=0;i<Bars;i++) if (res1[i] != EMPTY_VALUE) { res = res1[i]; sup = sup1[i]; break; }

      double chanellHeight = (res-sup)/_point;
         if (chanellHeight > MinimalChanellHeight)
                  string trade = ", Buy from "+DoubleToStr(res1[i],4)+", Sell from "+DoubleToStr(sup1[i],4);
            else         trade = ", not trading";
            Comment("\n","\n","Working server''s time: from ",st1," to ",et1," and from ",st2," to ",et2,
                         "\n","Width of the channel: ",(res-sup)/_point,trade);
   
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}